import "./style/bootstrap.min.css";
import "./style/style.css";
declare enum EnumDirection {
    left = "left",
    right = "right"
}
declare enum EnumSize {
    ms = "ms",
    md = "md"
}
declare enum EnumPaginationDirection {
    center = "center",
    start = "start",
    end = "end"
}
interface IHeaderItem {
    display: string;
    dataSourceKey: string;
    cellDataFormat?: ({ data, entireData, }: {
        data: any;
        entireData: any;
    }) => any;
    isAction?: boolean;
    popupDirection?: EnumDirection;
    actionItems?: IActionItem[];
    isSortable?: boolean;
    onAscendingSortArrowClicked?: any;
    onDescendingSortArrowClicked?: any;
    headerStyle?: any;
    cellStyle?: any;
}
interface IActionItem {
    label: string;
    onClick: (data: any) => any;
}
interface ITableDataView {
    noDataFoundText: string;
    headerItems: IHeaderItem[];
    dataSource: any[];
    onPaginationNumberClick: (pageNumber: number) => any;
    onPaginationPreviousClick: () => any;
    onPaginationNextClick: () => any;
    paginationPageLinkStyle: any;
    paginationContainerStyle: any;
    paginationPosition: EnumPaginationDirection;
    resetPagination: number | null;
    paginationNumberOfScreens: number;
    noPadding: boolean;
    bordered: boolean;
    borderless: boolean;
    striped: boolean;
    hover: boolean;
    size: EnumSize;
    autoPagination: boolean;
    autoPaginationSize: number;
    iconActionMenu: any;
    iconSortUp: any;
    iconSortDown: any;
    embeddedIconMenuActionStyle: any;
    embeddedIconSortUpStyle: any;
    embeddedIconSortDownStyle: any;
    activeSortIconColor: string;
}
declare const TableDataView: {
    ({ noDataFoundText, headerItems, dataSource, onPaginationNumberClick, onPaginationPreviousClick, onPaginationNextClick, paginationPageLinkStyle, paginationContainerStyle, paginationPosition, resetPagination, paginationNumberOfScreens, noPadding, bordered, borderless, striped, hover, size, autoPagination, autoPaginationSize, iconActionMenu, iconSortUp, iconSortDown, embeddedIconMenuActionStyle, embeddedIconSortUpStyle, embeddedIconSortDownStyle, activeSortIconColor, }: ITableDataView): any;
    tableSize: {
        small: string;
        medium: string;
    };
};
export { TableDataView };
