"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableDataView = void 0;
/* eslint-disable */
var react_1 = require("react");
var lodash_1 = require("lodash");
var GeneratedPagination_1 = require("./GeneratedPagination");
var IconSortDown_1 = require("./IconSortDown");
var IconSortUp_1 = require("./IconSortUp");
var Dropdown_1 = require("./Dropdown");
require("./style/bootstrap.min.css");
require("./style/style.css");
var EnumDirection;
(function (EnumDirection) {
    EnumDirection["left"] = "left";
    EnumDirection["right"] = "right";
})(EnumDirection || (EnumDirection = {}));
var EnumSize;
(function (EnumSize) {
    EnumSize["ms"] = "ms";
    EnumSize["md"] = "md";
})(EnumSize || (EnumSize = {}));
var EnumPaginationDirection;
(function (EnumPaginationDirection) {
    EnumPaginationDirection["center"] = "center";
    EnumPaginationDirection["start"] = "start";
    EnumPaginationDirection["end"] = "end";
})(EnumPaginationDirection || (EnumPaginationDirection = {}));
var TableDataView = function (_a) {
    var _b = _a.noDataFoundText, noDataFoundText = _b === void 0 ? "No Data Found" : _b, _c = _a.headerItems, headerItems = _c === void 0 ? [] : _c, _d = _a.dataSource, dataSource = _d === void 0 ? [] : _d, _e = _a.onPaginationNumberClick, onPaginationNumberClick = _e === void 0 ? function (pageNumber) { } : _e, _f = _a.onPaginationPreviousClick, onPaginationPreviousClick = _f === void 0 ? function () { } : _f, _g = _a.onPaginationNextClick, onPaginationNextClick = _g === void 0 ? function () { } : _g, _h = _a.paginationPageLinkStyle, paginationPageLinkStyle = _h === void 0 ? {} : _h, // style object
    _j = _a.paginationContainerStyle, // style object
    paginationContainerStyle = _j === void 0 ? {} : _j, // style object
    _k = _a.paginationPosition, // style object
    paginationPosition = _k === void 0 ? EnumPaginationDirection.center : _k, _l = _a.resetPagination, resetPagination = _l === void 0 ? null : _l, _m = _a.paginationNumberOfScreens, paginationNumberOfScreens = _m === void 0 ? 5 : _m, _o = _a.noPadding, noPadding = _o === void 0 ? false : _o, _p = _a.bordered, bordered = _p === void 0 ? true : _p, _q = _a.borderless, borderless = _q === void 0 ? false : _q, _r = _a.striped, striped = _r === void 0 ? false : _r, _s = _a.hover, hover = _s === void 0 ? false : _s, _t = _a.size, size = _t === void 0 ? EnumSize.md : _t, _u = _a.autoPagination, autoPagination = _u === void 0 ? false : _u, _v = _a.autoPaginationSize, autoPaginationSize = _v === void 0 ? 10 : _v, _w = _a.iconActionMenu, iconActionMenu = _w === void 0 ? null : _w, _x = _a.iconSortUp, iconSortUp = _x === void 0 ? null : _x, _y = _a.iconSortDown, iconSortDown = _y === void 0 ? null : _y, _z = _a.embeddedIconMenuActionStyle, embeddedIconMenuActionStyle = _z === void 0 ? null : _z, _0 = _a.embeddedIconSortUpStyle, embeddedIconSortUpStyle = _0 === void 0 ? null : _0, _1 = _a.embeddedIconSortDownStyle, embeddedIconSortDownStyle = _1 === void 0 ? null : _1, _2 = _a.activeSortIconColor, activeSortIconColor = _2 === void 0 ? "#cd4747" : _2;
    var _3 = react_1.useState({
        dataSrcKey: "",
        type: "",
    }), activeSortItem = _3[0], setActiveSortItem = _3[1];
    //---------------Auto pagination process
    var _4 = react_1.useState(1), pageNumber = _4[0], setPageNumber = _4[1];
    var navigator = lodash_1.slice(dataSource, (pageNumber - 1) * autoPaginationSize, pageNumber * autoPaginationSize); //custom navigator for pagination
    react_1.useEffect(function () {
        if (autoPagination) {
            if (resetPagination) {
                setPageNumber(resetPagination);
            }
        }
    }, [resetPagination]);
    //----------------
    //random string id generator
    var randomString = function (len) {
        if (len === void 0) { len = 5; }
        var str = ""; // String result
        for (var i = 0; i < len; i++) {
            // Loop `len` times
            var rand = Math.floor(Math.random() * 62); // random: 0..61
            var charCode = (rand += rand > 9 ? (rand < 36 ? 55 : 61) : 48); // Get correct charCode
            str += String.fromCharCode(charCode); // add Character to str
        }
        return str; // After all loops are done, return the concatenated string
    };
    // --- Inner Components
    var CoreTableHeaders = function () {
        var preKey = randomString(); // generate 5 chars
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("tr", null, headerItems &&
                headerItems.map(function (item, i) {
                    return (react_1.default.createElement("th", { key: preKey + i, style: __assign({}, item.headerStyle) },
                        item.display,
                        item.isSortable && (react_1.default.createElement(react_1.default.Fragment, null,
                            react_1.default.createElement(IconSortUp_1.IconSortUp, { icon: iconSortUp, embeddedIconStyle: embeddedIconSortUpStyle, onClick: function () {
                                    item.onAscendingSortArrowClicked(item.dataSourceKey);
                                    setActiveSortItem({
                                        dataSrcKey: item.dataSourceKey,
                                        type: "asc",
                                    });
                                }, activeSortItem: activeSortItem, activeSortIconColor: activeSortIconColor, dataSrcKey: item.dataSourceKey }),
                            react_1.default.createElement(IconSortDown_1.IconSortDown, { icon: iconSortDown, embeddedIconStyle: embeddedIconSortDownStyle, onClick: function () {
                                    item.onDescendingSortArrowClicked(item.dataSourceKey);
                                    setActiveSortItem({
                                        dataSrcKey: item.dataSourceKey,
                                        type: "desc",
                                    });
                                }, activeSortItem: activeSortItem, activeSortIconColor: activeSortIconColor, dataSrcKey: item.dataSourceKey })))));
                }))));
    };
    var TableRowData = function (props) {
        var data = props.data;
        var preKey = randomString(); // 5 chars string
        if (data && data.length > 0) {
            return data.map(function (item, i) {
                var data_row = headerItems.map(function (h_item, j) {
                    return (react_1.default.createElement("td", { key: preKey + "c" + j, style: __assign({}, h_item.cellStyle) },
                        h_item.dataSourceKey && // if cellDataFormat was present
                            h_item.dataSourceKey.trim().length > 0 &&
                            !h_item.isAction &&
                            h_item.cellDataFormat && (react_1.default.createElement(h_item.cellDataFormat, { data: item[h_item.dataSourceKey], entireData: item })),
                        h_item.dataSourceKey && // if cellDataFormat was not present
                            h_item.dataSourceKey.trim().length > 0 &&
                            !h_item.isAction &&
                            !h_item.cellDataFormat &&
                            item[h_item.dataSourceKey],
                        h_item.isAction && ( // action menu, if isAction was true and actionItems has items
                        react_1.default.createElement(Dropdown_1.default, { iconActionMenu: iconActionMenu, embeddedIconMenuActionStyle: embeddedIconMenuActionStyle, h_item: h_item, preKey: preKey, item: item, popupDirection: h_item.popupDirection }))));
                });
                return react_1.default.createElement("tr", { key: preKey + i }, data_row); //return each row data
            });
        }
        else {
            console.warn("NO Data FOUND", data);
            return react_1.default.createElement(NoDataFound, null);
        }
    };
    var NoDataFound = function () {
        return (react_1.default.createElement("tr", null,
            react_1.default.createElement("td", { colSpan: 11 },
                react_1.default.createElement("p", { style: { textAlign: "center" } }, noDataFoundText))));
    };
    return (react_1.default.createElement("div", { className: "container-fluid" },
        react_1.default.createElement("div", { className: "row" },
            react_1.default.createElement("div", { className: "col " + (noPadding ? "" : "p-5 ") },
                react_1.default.createElement("div", { style: { minHeight: "260px" } },
                    react_1.default.createElement("table", { className: "table" + (striped ? " table-striped" : "") + (bordered ? " table-bordered" : "") + (borderless ? " table-borderless" : "") + (hover ? " table-hover" : "") + (size && size === EnumSize.ms ? " table-sm" : "") },
                        react_1.default.createElement("thead", null,
                            react_1.default.createElement(CoreTableHeaders, null)),
                        react_1.default.createElement("tbody", null,
                            react_1.default.createElement(TableRowData, { data: autoPagination ? navigator : dataSource })))))),
        react_1.default.createElement("div", { className: "row" },
            react_1.default.createElement("div", { className: "col" },
                react_1.default.createElement("div", { className: "d-flex justify-content-" + paginationPosition + " align-items-center" },
                    react_1.default.createElement(GeneratedPagination_1.GeneratedPagination, { onClick: function (page_number) {
                            if (autoPagination) {
                                setPageNumber(page_number);
                            }
                            onPaginationNumberClick(page_number);
                        }, numberOfScreens: paginationNumberOfScreens, onPreviousArrow: onPaginationPreviousClick, onNextArrow: onPaginationNextClick, resetPagination: autoPagination ? pageNumber : resetPagination, paginationPageLinkStyle: paginationPageLinkStyle, paginationContainerStyle: paginationContainerStyle }))))));
};
exports.TableDataView = TableDataView;
// Add facility settings
// Table Size
TableDataView.tableSize = { small: "sm", medium: "md" };
