"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useClickOutside = void 0;
var react_1 = require("react");
function useClickOutside() {
    var ref = react_1.useRef();
    var _a = react_1.useState({
        hasClickedOutside: false,
    }), state = _a[0], setState = _a[1];
    function handleEvent(e) {
        /* istanbul ignore else  */
        if (ref && ref.current) {
            if (ref.current.contains(e.target)) {
                setState({ hasClickedOutside: false });
            }
            else {
                setState({ hasClickedOutside: true });
            }
        }
    }
    react_1.useEffect(function () {
        if (window.PointerEvent) {
            document.addEventListener("pointerdown", handleEvent);
        }
        else {
            document.addEventListener("mousedown", handleEvent);
            document.addEventListener("touchstart", handleEvent);
        }
        return function () {
            if (window.PointerEvent) {
                document.removeEventListener("pointerdown", handleEvent);
            }
            else {
                document.removeEventListener("mousedown", handleEvent);
                document.removeEventListener("touchstart", handleEvent);
            }
        };
    }, []);
    return [ref, state.hasClickedOutside];
}
exports.useClickOutside = useClickOutside;
